{    var   : }
{ N, GE }
Unit MNL3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNL31_p, MNL32_p;

procedure MNL3R(var N :Integer; var X :Array of Real; var XMIN :Real;
                var S :Array of Real; FUN :Proc_F1_MN; GRAD :Proc_F5_MN;
                AA :Real; BB :Real; XE :Real; var GE :Real;
                var I0 :Array of Integer; var UP :Array of Real;
                var RM :Array of Real; var IERR :Integer);

implementation

procedure MNL3R(var N :Integer; var X :Array of Real; var XMIN :Real;
                var S :Array of Real; FUN :Proc_F1_MN; GRAD :Proc_F5_MN;
                AA :Real; BB :Real; XE :Real; var GE :Real;
                var I0 :Array of Integer; var UP :Array of Real;
                var RM :Array of Real; var IERR :Integer);
var
I,I1,I2,ITER,IUP1,IUP2 :Integer;
A,B,F1,F2,FE,FV,G1,G2,GX,V,W,Z :Real;
const
RS :Real = 0.0;
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160;
begin

{     OHOMEPHA MHMA YHK MHOX EPEMEHHX }
{     O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE }

{     APAMETP: }
{     N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX }
{     X     -HAAHA TOKA OCKA }
{     XMIN  -PACCTOHE OT X O BCEHHO TOK }
{     S     -BEKTOP H N - HAPABEHE OCKA }
{     FUN   -M OPOPAMM BCEH YHK }
{     GRAD  -M OPOPAMM BCEH PAEHTA }
{     AA,BB -HH  BEPXH PAH HTEPBAA, }
{     XE    -TOHOCT O APYMEHTY }
{     GE    -TOHOCT O PAEHTY }
{     I    -KOPPEKTPY BEKTOP H N }
{     UP    -BEKTOP YPABX APAMETPOB }
{     RM    -PAO BEKTOP H 3N }
{     IERR  -PHAK OKOHAH POECCA: }
{           1 -OCTHYTA TOHOCT XE }
{           3 -OCTHYTA TOHOCT GE }
{           4 -BOHEHO UP(1) TEPA }
{           65-GRAD HA EBOM KOHE OTPEKA .GE. }
{               HA PABOM .LE. }
{           66-BEKTOP S  I OPTOOHAH }

IUP1 := Trunc( UP[0] + 0.5 );
IUP2 := Trunc( UP[1] + 0.5 );
ITER := 0;
A := AA;
B := BB;
I1 := N;
I2 := 2*N;

{     BCEHE HOPM BEKTOPA S C YETOM I }

for I:=1 to N do
 begin
  if ( I0[I-1] <=  ZERO ) 
   then goto _10;
  RS := RS + IntPower(S[I-1],2);
_10:
 end;
if ( RS >  ZERO ) 
 then goto _20;
IERR := 66;
goto _160;
_20:
RS := Sqrt(RS);
MNL31(N,X,S,A,RM,I0,0);
MNL31(N,X,S,B,RM,I0,I1);
GRAD(RM[0],RM[I2+0],GE,I0);
MNL32(N,RM,S,RS,G1,I0,I2);
GRAD(RM[I1+0],RM[I2+0],GE,I0);
MNL32(N,RM,S,RS,G2,I0,I2);

{     POBEPKA HAKOB POBOHO HA KOHAX (A,B) }

if ( (G1 >=  ZERO) ) or (  (G2 <=  ZERO) ) 
 then goto _90;

{     POBEPKA H KOHTPOHOO OTPEKA }

if ( (B - A)*0.5 <=  XE ) 
 then goto _100;
FUN(RM[0],F1,FE);
FUN(RM[I1+0],F2,FE);
_30:
ITER := ITER + 1;

{     POBEPKA CA TEPA }

if ( ITER >=  IUP1 ) 
 then goto _120;

{     POBEPKA H KOHTPOHOO OTPEKA }

if ( (B - A)*0.5 <=  XE ) 
 then goto _100;

{     BCEHE POMEYTOHO TOK (A,B) }

case IUP2 of
 1: goto _40;
 2: goto _50;
 3: goto _60;
end;
_40:
V := (F1 - F2 + B*G2 - A*G1)/(G2 - G1);
goto _70;
_50:
V := (B*G2 - A*G1)/(G2 - G1);
goto _70;
_60:
Z := 3.0*(F1 - F2)/(B - A);
Z := Z + G1 + G2;
W := Z*Z - G1*G2;
W := Sqrt(W);
V := (Z + G2 - W)*(B - A)/(G2 + G1 + 2*Z);
V := B - V;
_70:
MNL31(N,X,S,V,RM,I0,0);
GRAD(RM[0],RM[I2+0],GE,I0);
MNL32(N,RM,S,RS,GX,I0,I2);
FUN(RM[0],FV,FE);
if ( GX <=  GE ) 
 then goto _80;

{     CTAPOE V CTAHOBTC HOBM B }

B := V;
F2 := FV;
G2 := GX;
goto _30;
_80:
if ( GX >=  -GE ) 
 then goto _130;

{     CTAPOE V CTAHOBTC HOBM A }

A := V;
F1 := FV;
G1 := GX;
goto _30;

{     OPEEEHE BXOHX APAMETPOB }

_90:
IERR := 65;
goto _140;
_100:
IERR := 1;
goto _140;
_110:
IERR := 2;
goto _140;
_120:
IERR := 4;
goto _140;
_130:
IERR := 3;
XMIN := V;
goto _160;
_140:
if ( F1 >  F2 ) 
 then goto _150;
XMIN := A;
goto _160;
_150:
XMIN := B;
_160:
end;

end.
